// media/mojo/mojom/stable/stable_video_decoder.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_STABLE_STABLE_VIDEO_DECODER_MOJOM_BLINK_TEST_UTILS_H_
#define MEDIA_MOJO_MOJOM_STABLE_STABLE_VIDEO_DECODER_MOJOM_BLINK_TEST_UTILS_H_

#include "media/mojo/mojom/stable/stable_video_decoder.mojom-blink.h"


namespace media::stable::mojom::blink {


class  MediaLogInterceptorForTesting : public MediaLog {
  virtual MediaLog* GetForwardingInterface() = 0;
  void AddLogRecord(::media::stable::mojom::blink::MediaLogRecordPtr event) override;
};
class  MediaLogAsyncWaiter {
 public:
  explicit MediaLogAsyncWaiter(MediaLog* proxy);

  MediaLogAsyncWaiter(const MediaLogAsyncWaiter&) = delete;
  MediaLogAsyncWaiter& operator=(const MediaLogAsyncWaiter&) = delete;

  ~MediaLogAsyncWaiter();

 private:
  MediaLog* const proxy_;
};


class  VideoFrameHandleReleaserInterceptorForTesting : public VideoFrameHandleReleaser {
  virtual VideoFrameHandleReleaser* GetForwardingInterface() = 0;
  void ReleaseVideoFrame(const ::base::UnguessableToken& release_token) override;
};
class  VideoFrameHandleReleaserAsyncWaiter {
 public:
  explicit VideoFrameHandleReleaserAsyncWaiter(VideoFrameHandleReleaser* proxy);

  VideoFrameHandleReleaserAsyncWaiter(const VideoFrameHandleReleaserAsyncWaiter&) = delete;
  VideoFrameHandleReleaserAsyncWaiter& operator=(const VideoFrameHandleReleaserAsyncWaiter&) = delete;

  ~VideoFrameHandleReleaserAsyncWaiter();

 private:
  VideoFrameHandleReleaser* const proxy_;
};


class  VideoDecoderClientInterceptorForTesting : public VideoDecoderClient {
  virtual VideoDecoderClient* GetForwardingInterface() = 0;
  void OnVideoFrameDecoded(::media::stable::mojom::blink::VideoFramePtr frame, bool can_read_without_stalling, const ::base::UnguessableToken& release_token) override;
  void OnWaiting(::media::stable::mojom::blink::WaitingReason reason) override;
};
class  VideoDecoderClientAsyncWaiter {
 public:
  explicit VideoDecoderClientAsyncWaiter(VideoDecoderClient* proxy);

  VideoDecoderClientAsyncWaiter(const VideoDecoderClientAsyncWaiter&) = delete;
  VideoDecoderClientAsyncWaiter& operator=(const VideoDecoderClientAsyncWaiter&) = delete;

  ~VideoDecoderClientAsyncWaiter();

 private:
  VideoDecoderClient* const proxy_;
};


class  CdmContextEventCallbackInterceptorForTesting : public CdmContextEventCallback {
  virtual CdmContextEventCallback* GetForwardingInterface() = 0;
  void EventCallback(::media::stable::mojom::blink::CdmContextEvent event) override;
};
class  CdmContextEventCallbackAsyncWaiter {
 public:
  explicit CdmContextEventCallbackAsyncWaiter(CdmContextEventCallback* proxy);

  CdmContextEventCallbackAsyncWaiter(const CdmContextEventCallbackAsyncWaiter&) = delete;
  CdmContextEventCallbackAsyncWaiter& operator=(const CdmContextEventCallbackAsyncWaiter&) = delete;

  ~CdmContextEventCallbackAsyncWaiter();

 private:
  CdmContextEventCallback* const proxy_;
};


class  StableCdmContextInterceptorForTesting : public StableCdmContext {
  virtual StableCdmContext* GetForwardingInterface() = 0;
  void GetHwKeyData(::media::stable::mojom::blink::DecryptConfigPtr decrypt_config, const WTF::Vector<uint8_t>& hw_identifier, GetHwKeyDataCallback callback) override;
  void RegisterEventCallback(::mojo::PendingRemote<CdmContextEventCallback> callback) override;
  void GetHwConfigData(GetHwConfigDataCallback callback) override;
  void GetScreenResolutions(GetScreenResolutionsCallback callback) override;
  void AllocateSecureBuffer(uint32_t size, AllocateSecureBufferCallback callback) override;
  void ParseEncryptedSliceHeader(uint64_t secure_handle, uint32_t offset, const WTF::Vector<uint8_t>& stream_data, ParseEncryptedSliceHeaderCallback callback) override;
  void DecryptVideoBuffer(::media::stable::mojom::blink::DecoderBufferPtr buffer, const WTF::Vector<uint8_t>& bytes, DecryptVideoBufferCallback callback) override;
};
class  StableCdmContextAsyncWaiter {
 public:
  explicit StableCdmContextAsyncWaiter(StableCdmContext* proxy);

  StableCdmContextAsyncWaiter(const StableCdmContextAsyncWaiter&) = delete;
  StableCdmContextAsyncWaiter& operator=(const StableCdmContextAsyncWaiter&) = delete;

  ~StableCdmContextAsyncWaiter();
  void GetHwKeyData(
      ::media::stable::mojom::blink::DecryptConfigPtr decrypt_config, const WTF::Vector<uint8_t>& hw_identifier, ::media::stable::mojom::blink::DecryptStatus* out_status, WTF::Vector<uint8_t>* out_key_data);
  
  void GetHwConfigData(
      bool* out_success, WTF::Vector<uint8_t>* out_config_data);
  
  void GetScreenResolutions(
      WTF::Vector<::gfx::Size>* out_resolutions);
  WTF::Vector<::gfx::Size> GetScreenResolutions();
  void AllocateSecureBuffer(
      uint32_t size, ::mojo::PlatformHandle* out_secure_buffer);
  ::mojo::PlatformHandle AllocateSecureBuffer(uint32_t size);
  void ParseEncryptedSliceHeader(
      uint64_t secure_handle, uint32_t offset, const WTF::Vector<uint8_t>& stream_data, bool* out_success, WTF::Vector<uint8_t>* out_slice_header);
  
  void DecryptVideoBuffer(
      ::media::stable::mojom::blink::DecoderBufferPtr buffer, const WTF::Vector<uint8_t>& bytes, ::media::stable::mojom::blink::DecryptStatus* out_status, ::media::stable::mojom::blink::DecoderBufferPtr* out_decoder_buffer, WTF::Vector<uint8_t>* out_bytes);
  

 private:
  StableCdmContext* const proxy_;
};


class  StableVideoDecoderInterceptorForTesting : public StableVideoDecoder {
  virtual StableVideoDecoder* GetForwardingInterface() = 0;
  void GetSupportedConfigs(GetSupportedConfigsCallback callback) override;
  void Construct(::mojo::PendingAssociatedRemote<VideoDecoderClient> client, ::mojo::PendingRemote<MediaLog> media_log, ::mojo::PendingReceiver<VideoFrameHandleReleaser> video_frame_handle_releaser, ::mojo::ScopedDataPipeConsumerHandle decoder_buffer_pipe, ::media::stable::mojom::blink::ColorSpacePtr target_color_space) override;
  void Initialize(::media::stable::mojom::blink::VideoDecoderConfigPtr config, bool low_delay, ::mojo::PendingRemote<StableCdmContext> cdm_context, InitializeCallback callback) override;
  void Decode(::media::stable::mojom::blink::DecoderBufferPtr buffer, DecodeCallback callback) override;
  void Reset(ResetCallback callback) override;
};
class  StableVideoDecoderAsyncWaiter {
 public:
  explicit StableVideoDecoderAsyncWaiter(StableVideoDecoder* proxy);

  StableVideoDecoderAsyncWaiter(const StableVideoDecoderAsyncWaiter&) = delete;
  StableVideoDecoderAsyncWaiter& operator=(const StableVideoDecoderAsyncWaiter&) = delete;

  ~StableVideoDecoderAsyncWaiter();
  void GetSupportedConfigs(
      WTF::Vector<::media::stable::mojom::blink::SupportedVideoDecoderConfigPtr>* out_supported_configs, ::media::stable::mojom::blink::VideoDecoderType* out_decoder_type);
  
  void Initialize(
      ::media::stable::mojom::blink::VideoDecoderConfigPtr config, bool low_delay, ::mojo::PendingRemote<StableCdmContext> cdm_context, ::media::stable::mojom::blink::StatusPtr* out_status, bool* out_needs_bitstream_conversion, int32_t* out_max_decode_requests, ::media::stable::mojom::blink::VideoDecoderType* out_decoder_type, bool* out_needs_transcryption);
  
  void Decode(
      ::media::stable::mojom::blink::DecoderBufferPtr buffer, ::media::stable::mojom::blink::StatusPtr* out_status);
  ::media::stable::mojom::blink::StatusPtr Decode(::media::stable::mojom::blink::DecoderBufferPtr buffer);
  void Reset(
      );
  

 private:
  StableVideoDecoder* const proxy_;
};


class  StableVideoDecoderTrackerInterceptorForTesting : public StableVideoDecoderTracker {
  virtual StableVideoDecoderTracker* GetForwardingInterface() = 0;
};
class  StableVideoDecoderTrackerAsyncWaiter {
 public:
  explicit StableVideoDecoderTrackerAsyncWaiter(StableVideoDecoderTracker* proxy);

  StableVideoDecoderTrackerAsyncWaiter(const StableVideoDecoderTrackerAsyncWaiter&) = delete;
  StableVideoDecoderTrackerAsyncWaiter& operator=(const StableVideoDecoderTrackerAsyncWaiter&) = delete;

  ~StableVideoDecoderTrackerAsyncWaiter();

 private:
  StableVideoDecoderTracker* const proxy_;
};


class  StableVideoDecoderFactoryInterceptorForTesting : public StableVideoDecoderFactory {
  virtual StableVideoDecoderFactory* GetForwardingInterface() = 0;
  void CreateStableVideoDecoder(::mojo::PendingReceiver<StableVideoDecoder> receiver, ::mojo::PendingRemote<StableVideoDecoderTracker> tracker) override;
};
class  StableVideoDecoderFactoryAsyncWaiter {
 public:
  explicit StableVideoDecoderFactoryAsyncWaiter(StableVideoDecoderFactory* proxy);

  StableVideoDecoderFactoryAsyncWaiter(const StableVideoDecoderFactoryAsyncWaiter&) = delete;
  StableVideoDecoderFactoryAsyncWaiter& operator=(const StableVideoDecoderFactoryAsyncWaiter&) = delete;

  ~StableVideoDecoderFactoryAsyncWaiter();

 private:
  StableVideoDecoderFactory* const proxy_;
};


class  StableVideoDecoderFactoryProcessInterceptorForTesting : public StableVideoDecoderFactoryProcess {
  virtual StableVideoDecoderFactoryProcess* GetForwardingInterface() = 0;
  void InitializeStableVideoDecoderFactory(::gpu::mojom::blink::GpuFeatureInfoPtr gpu_feature_info, bool enable_direct_video_decoder, ::mojo::PendingReceiver<StableVideoDecoderFactory> receiver) override;
};
class  StableVideoDecoderFactoryProcessAsyncWaiter {
 public:
  explicit StableVideoDecoderFactoryProcessAsyncWaiter(StableVideoDecoderFactoryProcess* proxy);

  StableVideoDecoderFactoryProcessAsyncWaiter(const StableVideoDecoderFactoryProcessAsyncWaiter&) = delete;
  StableVideoDecoderFactoryProcessAsyncWaiter& operator=(const StableVideoDecoderFactoryProcessAsyncWaiter&) = delete;

  ~StableVideoDecoderFactoryProcessAsyncWaiter();

 private:
  StableVideoDecoderFactoryProcess* const proxy_;
};




}  // media::stable::mojom::blink

#endif  // MEDIA_MOJO_MOJOM_STABLE_STABLE_VIDEO_DECODER_MOJOM_BLINK_TEST_UTILS_H_