// third_party/blink/public/mojom/webauthn/virtual_authenticator.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBAUTHN_VIRTUAL_AUTHENTICATOR_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBAUTHN_VIRTUAL_AUTHENTICATOR_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/webauthn/virtual_authenticator.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink::test::mojom::blink {


class PLATFORM_EXPORT VirtualAuthenticatorInterceptorForTesting : public VirtualAuthenticator {
  virtual VirtualAuthenticator* GetForwardingInterface() = 0;
  void GetUniqueId(GetUniqueIdCallback callback) override;
  void AddRegistration(RegisteredKeyPtr key, AddRegistrationCallback callback) override;
  void GetRegistrations(GetRegistrationsCallback callback) override;
  void RemoveRegistration(const WTF::Vector<uint8_t>& key_handle, RemoveRegistrationCallback callback) override;
  void ClearRegistrations(ClearRegistrationsCallback callback) override;
  void GetLargeBlob(const WTF::Vector<uint8_t>& key_handle, GetLargeBlobCallback callback) override;
  void SetLargeBlob(const WTF::Vector<uint8_t>& key_handle, const WTF::Vector<uint8_t>& blob, SetLargeBlobCallback callback) override;
  void SetUserVerified(bool verified, SetUserVerifiedCallback callback) override;
};
class PLATFORM_EXPORT VirtualAuthenticatorAsyncWaiter {
 public:
  explicit VirtualAuthenticatorAsyncWaiter(VirtualAuthenticator* proxy);

  VirtualAuthenticatorAsyncWaiter(const VirtualAuthenticatorAsyncWaiter&) = delete;
  VirtualAuthenticatorAsyncWaiter& operator=(const VirtualAuthenticatorAsyncWaiter&) = delete;

  ~VirtualAuthenticatorAsyncWaiter();
  void GetUniqueId(
      WTF::String* out_id);
  WTF::String GetUniqueId();
  void AddRegistration(
      RegisteredKeyPtr key, bool* out_added);
  bool AddRegistration(RegisteredKeyPtr key);
  void GetRegistrations(
      WTF::Vector<RegisteredKeyPtr>* out_keys);
  WTF::Vector<RegisteredKeyPtr> GetRegistrations();
  void RemoveRegistration(
      const WTF::Vector<uint8_t>& key_handle, bool* out_removed);
  bool RemoveRegistration(const WTF::Vector<uint8_t>& key_handle);
  void ClearRegistrations(
      );
  
  void GetLargeBlob(
      const WTF::Vector<uint8_t>& key_handle, std::optional<WTF::Vector<uint8_t>>* out_blob);
  std::optional<WTF::Vector<uint8_t>> GetLargeBlob(const WTF::Vector<uint8_t>& key_handle);
  void SetLargeBlob(
      const WTF::Vector<uint8_t>& key_handle, const WTF::Vector<uint8_t>& blob, bool* out_set);
  bool SetLargeBlob(const WTF::Vector<uint8_t>& key_handle, const WTF::Vector<uint8_t>& blob);
  void SetUserVerified(
      bool verified);
  

 private:
  VirtualAuthenticator* const proxy_;
};


class PLATFORM_EXPORT VirtualAuthenticatorManagerInterceptorForTesting : public VirtualAuthenticatorManager {
  virtual VirtualAuthenticatorManager* GetForwardingInterface() = 0;
  void CreateAuthenticator(VirtualAuthenticatorOptionsPtr options, CreateAuthenticatorCallback callback) override;
  void GetAuthenticators(GetAuthenticatorsCallback callback) override;
  void RemoveAuthenticator(const WTF::String& id, RemoveAuthenticatorCallback callback) override;
  void ClearAuthenticators(ClearAuthenticatorsCallback callback) override;
};
class PLATFORM_EXPORT VirtualAuthenticatorManagerAsyncWaiter {
 public:
  explicit VirtualAuthenticatorManagerAsyncWaiter(VirtualAuthenticatorManager* proxy);

  VirtualAuthenticatorManagerAsyncWaiter(const VirtualAuthenticatorManagerAsyncWaiter&) = delete;
  VirtualAuthenticatorManagerAsyncWaiter& operator=(const VirtualAuthenticatorManagerAsyncWaiter&) = delete;

  ~VirtualAuthenticatorManagerAsyncWaiter();
  void CreateAuthenticator(
      VirtualAuthenticatorOptionsPtr options, ::mojo::PendingRemote<VirtualAuthenticator>* out_authenticator);
  ::mojo::PendingRemote<VirtualAuthenticator> CreateAuthenticator(VirtualAuthenticatorOptionsPtr options);
  void GetAuthenticators(
      WTF::Vector<::mojo::PendingRemote<VirtualAuthenticator>>* out_authenticators);
  WTF::Vector<::mojo::PendingRemote<VirtualAuthenticator>> GetAuthenticators();
  void RemoveAuthenticator(
      const WTF::String& id, bool* out_removed);
  bool RemoveAuthenticator(const WTF::String& id);
  void ClearAuthenticators(
      );
  

 private:
  VirtualAuthenticatorManager* const proxy_;
};




}  // blink::test::mojom::blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBAUTHN_VIRTUAL_AUTHENTICATOR_MOJOM_BLINK_TEST_UTILS_H_