#include "src/objects/js-disposable-stack-inl.h"

#include "torque-generated/class-verifiers.h"
#include "src/objects/instance-type-inl.h"

namespace v8 {
namespace internal {

// https://source.chromium.org/chromium/chromium/src/+/main:v8/src/objects/js-disposable-stack.tq?l=12&c=1
bool IsJSDisposableStack_NonInline(Tagged<HeapObject> o) {
  return IsJSDisposableStack(o);
}

#ifdef VERIFY_HEAP

template <>
void TorqueGeneratedJSDisposableStack<JSDisposableStack, JSObject>::JSDisposableStackVerify(Isolate* isolate) {
  TorqueGeneratedClassVerifiers::JSDisposableStackVerify(JSDisposableStack::cast(*this), isolate);
}


#endif  // VERIFY_HEAP
} // namespace internal
} // namespace v8
